from __future__ import absolute_import, unicode_literals

from virtualenv.util.path import Path

from ..via_template import ViaTemplateActivator


class PowerShellActivator(ViaTemplateActivator):
    @staticmethod
    def quote(string):
        """
        This should satisfy PowerShell quoting rules [1], unless the quoted
        string is passed directly to Windows native commands [2].

        [1]: https://learn.microsoft.com/en-us/powershell/module/microsoft.powershell.core/about/about_quoting_rules
        [2]: https://learn.microsoft.com/en-us/powershell/module/microsoft.powershell.core/about/about_parsing#passing-arguments-that-contain-quote-characters
        """  # noqa: D205
        string = string.replace("'", "''")
        return f"'{string}'"

    def templates(self):
        yield Path("activate.ps1")
